; DISEQC 1.2 TO NOKIA ACU 8152
; version 1.1
; Compiled in MPLAB IDE downloaded from www.microchip.com


#include <P16F627.inc>


__CONFIG _PWRTE_OFF & _XT_OSC & _BODEN_OFF & _CP_OFF & _LVP_OFF & _WDT_OFF & _MCLRE_OFF

ACUPB           EQU 0x3
STBBUTTON       EQU 0x5

TMP             EQU 0x20
POWERON         EQU 0x21
PARITY          EQU 0x22
V1              EQU 0x23
V2              EQU 0x24
SATPOS          EQU 0x25
DSQTIME         EQU 0x26
DSQBIT          EQU 0x27
DSQCNT          EQU 0x28
DSQBUF          EQU 0x30
TMP0            EQU 0x40
TMP1            EQU 0x41
TMP2            EQU 0x42
TMPW            EQU 0x70
TMPS            EQU 0x71



                ORG     0x0
                goto    Start

                ORG     0x4        
Interrupt
                movwf   TMPW
                swapf   STATUS,W
                bcf     STATUS,RP0                
                movwf   TMPS
                btfsc   INTCON,INTF
                goto    Diseq
IEEnd
                swapf   TMPS,W                
                movwf   STATUS
                swapf   TMPW,F
                swapf   TMPW,W
                retfie

Diseq
                movfw   TMR0
                movwf   DSQTIME                               
                clrf    TMR0
                bsf     STATUS,RP0
                movlw   b'11000110'
                movwf   OPTION_REG
                bcf     STATUS,RP0

                btfsc   INTCON,T0IF
                goto    DiseqLS
                movlw   .16
                subwf   DSQTIME,W
                btfsc   STATUS,C
                goto    DiseqLS

                movfw   DSQTIME         
                btfsc   STATUS,Z
                goto    DiseqEnd

                incf    DSQCNT,F
                movlw   .9
                subwf   DSQCNT,W
                btfsc   STATUS,Z
                goto    DiseqCont

                movlw   .6
                subwf   DSQTIME,W
                btfss   STATUS,C
                goto    DiseqNext

                movlw   DSQBUF
                addwf   DSQBUF,W
                movwf   FSR
                movfw   INDF
                iorwf   DSQBIT,W
                movwf   INDF
DiseqNext
                bcf     STATUS,C
                rrf     DSQBIT,F
                goto    DiseqCheck
DiseqCont
                movlw   b'10000000'
                movwf   DSQBIT
                clrf    DSQCNT
                incf    DSQBUF,F
DiseqCheck
                movlw   .4
                subwf   DSQBUF,W
                btfss   STATUS,C
                goto    DiseqEnd
                movlw   .8
                subwf   DSQCNT,W
                btfss   STATUS,C
                goto    DiseqEnd
DiseqLS
                call    DSQReceived
DiseqEnd
                bcf     INTCON,T0IF
                bcf     INTCON,INTF
                goto    IEEnd



Start   
                bsf     STATUS,RP0
                movlw   b'11111111'
                movwf   TRISA
                movlw   b'11110111'
                movwf   TRISB
                movlw   b'11000110'
                movwf   OPTION_REG        
                bcf     STATUS,RP0

                movlw   b'00000101'
                movwf   CMCON
                bsf     STATUS,RP0
                movlw   b'11101000'
                movwf   VRCON
                bcf     PIE1,CMIE
                bcf     STATUS,RP0
                movlw   b'11010000'
                movwf   INTCON
                clrf    POWERON
                clrw
                call    BitOut
                movlw   0x0F
                movwf   DSQBUF
                call    ClearDSQBuffer

Loop
                btfss   PORTB,STBBUTTON
                call    PowerDown
                bcf     PIR1,CMIF            

                call    Delay50ms
                movfw   POWERON
                btfsc   STATUS,Z
                goto    ContLoop
                incf    POWERON,F
                movlw   .20
                subwf   POWERON,W
                btfss   STATUS,C
                goto    ContLoop
                movlw   .1
                movwf   POWERON
                btfss   CMCON,C2OUT
                goto    Loop
                call    PowerDown
ContLoop
                goto    Loop


PowerDown
                bcf     INTCON,GIE
                clrf    POWERON
                clrw
                call    SetPositioner
                bsf     INTCON,GIE
                return


DSQReceived
                movfw   DSQBUF+2                
                sublw   0x31
                btfss   STATUS,Z
                goto    DSQRecClear
                movfw   DSQBUF+3
                sublw   0x6B                                
                btfss   STATUS,Z
                goto    DSQRecClear
                movfw   DSQBUF+4
                call    SetPositioner
                movlw   .1
                movwf   POWERON
DSQRecClear
                call    ClearDSQBuffer        
                return


ClearDSQBuffer
                movf    DSQBUF,F
                btfsc   STATUS,Z
                return
                movlw   DSQBUF
                addwf   DSQBUF,W
                movwf   FSR
                clrw
                movwf   INDF
                decf    DSQBUF,F
                btfss   STATUS,Z
                goto    ClearDSQBuffer
                movlw   b'10000000'
                movwf   DSQBIT
                clrf    DSQCNT
                movlw   .1
                movwf   DSQBUF
                return


Delay_                                
                movwf   TMP0
N0              movlw   .99
                movwf   TMP1
N1              movlw   .162        
                movwf   TMP2
N2              decfsz  TMP2,F                
                goto    N2
                decfsz  TMP1,F
                goto    N1
                decfsz  TMP0,F                
                goto    N0
                return

Delay50ms
                movlw   .1
                call    Delay_
                return

Delay400us                        
                movlw   .130                
                movwf   TMP
N400            decfsz  TMP,F
                goto    N400
                return


BitOut
                btfsc   STATUS,Z
                goto    BitClear
                bcf     PORTB,ACUPB
                goto    BitOutDelay
BitClear
                bsf     PORTB,ACUPB
BitOutDelay
                call    Delay400us
                return


SetPositioner
                movwf   SATPOS
                clrf    PARITY
                movlw   b'10000000'
                movwf   V1
GO1             movfw   SATPOS
                andwf   V1,W
                btfsc   STATUS,Z
                incf    PARITY,F
                bcf     STATUS,C
                rrf     V1,F
                movf    V1,F
                btfss   STATUS,Z
                goto    GO1

                btfss   PARITY,0                
                clrf    PARITY

                clrw
                call    BitOut                
                movlw   5
                movwf   V1
GO2             decf    V1,F
                clrw
                addlw   1
                call    BitOut
                clrw
                call    BitOut                
                movf    V1,F                        
                btfss   STATUS,Z
                goto    GO2

                movlw   32
                movwf   V1
GO3             decf    V1,F
                clrw
                call    BitOut                
                movf    V1,F                        
                btfss   STATUS,Z
                goto    GO3

                clrw
                addlw   1
                call    BitOut

                movf    SATPOS,F     
                btfsc   STATUS,Z
                goto    StandBy

                movlw   b'00000001'
                movwf   V1
GO4             clrw
                movwf   V2
                movfw   SATPOS
                andwf   V1,W
                btfsc   STATUS,Z
                incf    V2,F
                movfw   V2
                call    BitOut
                bcf     STATUS,C
                rlf     V1,F
                movf    V1,F
                btfss   STATUS,Z
                goto    GO4
                goto    GOEND
StandBy
                movlw   4
                movwf   V1
GO5             decf    V1,F
                clrw
                addlw   1
                call    BitOut
                movf    V1,F
                btfss   STATUS,Z
                goto    GO5
GOEND
                clrw
                movf    PARITY,F
                btfss   STATUS,Z
                addlw   1
                call    BitOut
                clrw
                call    BitOut        
                return


                END

